/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2019 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "lcd_hd44780_lib.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */
typedef enum {FALSE = 0, TRUE = !FALSE} bool;
/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */
void Opcja1(void){
  HAL_GPIO_TogglePin(GPIOB, GPIO_PIN_8);
}

void Opcja2(void){
  HAL_GPIO_TogglePin(GPIOB, GPIO_PIN_9);
}

void Opcja3(void){
  HAL_GPIO_TogglePin(GPIOB, GPIO_PIN_10);
}

void Opcja4(void){
  HAL_GPIO_TogglePin(GPIOB, GPIO_PIN_11);
}

void Opcja5(void){
  HAL_GPIO_TogglePin(GPIOB, GPIO_PIN_12);
}

void Opcja6(void){
  HAL_GPIO_TogglePin(GPIOB, GPIO_PIN_13);
}

void Opcja7(void){
  HAL_GPIO_TogglePin(GPIOB, GPIO_PIN_14);
}

void Opcja8(void){
  HAL_GPIO_TogglePin(GPIOB, GPIO_PIN_15);
}

void Opcja9(void){
  char znak=1;
  LCD_WriteTextXY(&znak,15,0);
}

void Opcja10(void){
   char znak=2;
  LCD_WriteTextXY(&znak,15,0);
}


void Opcja11(void){
  char znak=3;
  LCD_WriteTextXY(&znak,15,0);
}

void Opcja12(void){
  char znak=4;
  LCD_WriteTextXY(&znak,15,0);
}

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */
  unsigned char pozycja=1;
  char *menu[12] = {"Dioda 1  ", "Dioda 2  ", "Dioda 3  ", "Dioda 4  ", "Dioda 5  ", "Dioda 6  ", "Dioda 7  ", "Dioda 8  ", "Bat.   0%", "Bat.  50%", "Bat. 100%", "Klepsydra"};
  const char znakiDodatkowe[32] =
            {0x04,0x1F,0x11,0x11,0x11,0x11,0x1F,0,  //bateria pusta
	         0x04,0x1F,0x11,0x11,0x1F,0x1F,0x1F,0,  //bateria 50%
	         0x04,0x1F,0x1F,0x1F,0x1F,0x1F,0x1F,0,  //bateria pełna
	         0x1F,0x0A,0x0A,0x04,0x0E,0x0E,0x1F,0}; //klepsydra
  bool odswiezLCD=TRUE;

  /* USER CODE END 1 */
  

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  /* USER CODE BEGIN 2 */

  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  LCD_Initialize();                           //inicjalizacja wywsietlacza
  LCD_SetUserChar(1, 4, znakiDodatkowe);      //zarejestruj dodatkowe znaki
  LCD_WriteCommand(HD44780_CLEAR);            //wyczysc wyświetlacz
  LCD_WriteText("[ \0");
  LCD_WriteText(menu[pozycja-1]);
  LCD_WriteText(" ]\0");
  LCD_WriteTextXY(menu[pozycja-1+1],2,1);

  while (1)
  {
	if (!HAL_GPIO_ReadPin(GPIOA, GPIO_PIN_1) && (pozycja<12)) {
	  pozycja++;
	  odswiezLCD=TRUE;
	}

	if (!HAL_GPIO_ReadPin(GPIOA, GPIO_PIN_0) && (pozycja>1)) {
	  pozycja--;
	  odswiezLCD=TRUE;
	}

	if (odswiezLCD){                           //Odswiezanie LCD tylko przy zmiane zawartosci - usuwa problem "migotania" LCD
	  LCD_WriteCommand(HD44780_CLEAR);
	  LCD_WriteText("[ ");
	  LCD_WriteText(menu[pozycja-1]);
	  LCD_WriteText(" ]");
	  if (pozycja<12){
		LCD_WriteTextXY(menu[pozycja-1+1],2,1);
	  }
	  odswiezLCD=FALSE;
	}

    if (!HAL_GPIO_ReadPin(GPIOC, GPIO_PIN_5)){
	  switch (pozycja){
		case 1: Opcja1(); break;
		case 2: Opcja2(); break;
		case 3: Opcja3(); break;
		case 4: Opcja4(); break;
		case 5: Opcja5(); break;
		case 6: Opcja6(); break;
		case 7: Opcja7(); break;
		case 8: Opcja8(); break;
		case 9: Opcja9(); break;
		case 10: Opcja10(); break;
		case 11: Opcja11(); break;
		case 12: Opcja12(); break;
		default: Opcja1(); break;
	  }
	}


	HAL_Delay(500);
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.HSEPredivValue = RCC_HSE_PREDIV_DIV1;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL9;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2) != HAL_OK)
  {
    Error_Handler();
  }
}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */

  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{ 
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     tex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
